/**  Client.java applet for sent the requst to servlet by http connect
     to the database. 
     Errors and informational messages can be viewed on the screan.
 API:
    void Init();
    void search( String, String, String );
    void update( String, String, String, String, string, string, string, string );
    void adddate( String, String, String, String, string, string, string, string );
    void delete_date( String, string );
    void destroy();
@author: Gang Wei
@version:1.1
 **/

import java.awt.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.*;

public class Project2_Client extends Applet {
  
  public Panel headerPanel;

  private String servletURL = "http://osprey4.npac.syr.edu:8001/servlets/Project2_DBservlet?";
  
 /**Input:void
    Output:void
    Function:Initilize the screen.
 **/
  public void init() {
    // set background color to lightGray, add HeaderPanel, 
    setBackground(Color.pink);
    headerPanel = new Panel();
    headerPanel.setFont(new Font("Helvetica", Font.PLAIN, 24));
    headerPanel.add(new Label("Database Connectivity Test"));
    add("North", headerPanel);
    //buttons!
    add("Center",  control = new Control(this));
  }
 

  
  /**Inoput:name,job and id. 
     Output:void
     Function:search for the input and output files, time the grogram be 
              sent and done, type of program, and annotation from table of  
              process_idtable.  
  **/
  public void search( String a, String b, String c ) {

    StringBuffer temp = new StringBuffer();
    temp.append( "search=ture&insert=false&update=false&delete=false&" );
    temp.append( "name=" );
    temp.append( a );
    temp.append( "&job=" );
    temp.append( b );
    temp.append( "&id=" );
    temp.append( c );
    try {
      System.out.println("open connection to "+servletURL+temp.toString());
      URL url = new java.net.URL( servletURL + temp.toString() );
      AppletContext ac = getAppletContext();
      ac.showDocument( url );//connect to web server and get result back 
      
    }
    catch ( MalformedURLException ex ){
     System.err.println( "Can't open URL: " + servletURL + ex );
    }
    catch( IOException e ){
     System.err.println( "Conection is wrong: " + e );
     }
   }


/**Input:user name, job, id, input and output files, time the job be sent and done,
            type of job, and annotation.
   Output:void
   Function:updata the process in the process_idtable.
*/
   public void update( String a, String b, String c, String d, String e, String f, String g ) {

    Calendar calendar = Calendar. getInstance(); 
    Date date = calendar.getTime();
    String times = String.valueOf( date.getTime() );
    String timed = times;
    System.out.println( times );
    StringBuffer temp = new StringBuffer();
    temp.append( "search=false&insert=false&update=ture&delete=false&" );
    temp.append( "name=" );
    temp.append( a );
    temp.append( "&job=" );
    temp.append( b );
    temp.append( "&id=" );
    temp.append( c );
    temp.append( "&inputf=" );
    temp.append( d );
    temp.append( "&outputf=" );
    temp.append( e );
    temp.append( "&times=" );
    temp.append( times );
    temp.append( "&timed=" );
    temp.append( timed );
    temp.append( "&type=" );
    temp.append( f );
    temp.append( "&ann=" );
    temp.append( g );
    try {
      System.out.println("open connection to "+servletURL+temp.toString());
      URL url = new java.net.URL( servletURL + temp.toString() );
      AppletContext ac = getAppletContext();
      ac.showDocument( url );//connect the web server and get result back.
    }
    catch ( MalformedURLException ex ){
     System.err.println( "Can't open URL: " + servletURL + ex );
    }
    catch( IOException ext ){
     System.err.println( "Conection is wrong: " + ext );
     }

  }//update

/**  Input:name, job, id, input and output files, time the job be sent and done,
            type of job, and annotation.
      Output:void
      Function:add a new information of the process in the process_idtable.
*/
   public void adddate( String a, String b, String c, String d, String e, String f, String g ) {

    Calendar calendar = Calendar.getInstance(); 
    Date date = calendar.getTime();
    String times = String.valueOf( date.getTime() );

    String timed = times;
    System.out.println( times );

    StringBuffer temp = new StringBuffer();
    temp.append( "search=false&insert=ture&update=false&delete=false&" );
    temp.append( "name=" );
    temp.append( a );
    temp.append( "&job=" );
    temp.append( b );
    temp.append( "&id=" );
    temp.append( c );
    temp.append( "&inputf=" );
    temp.append( d );
    temp.append( "&outputf=" );
    temp.append( e );
    temp.append( "&times=" );
    temp.append( times );
    temp.append( "&timed=" );
    temp.append( timed );
    temp.append( "&type=" );
    temp.append( f );
    temp.append( "&ann=" );
    temp.append( g );
    try {
      System.out.println("open connection to "+servletURL+temp.toString());
      URL url = new java.net.URL( servletURL + temp.toString() );
      AppletContext ac = getAppletContext();
      ac.showDocument(url);
    }
    catch ( MalformedURLException ex ){
     System.err.println( "Can't open URL: " + servletURL + ex );
    }
    catch( IOException ext ){
     System.err.println( "Conection is wrong: " + ext );
     }

  }//adddate


 /**Input:user name and job.
    Output:void
    Function:delete a process.
 **/
   public void delete_date( String name, String job ) {

    StringBuffer temp = new StringBuffer();
    temp.append( "search=false&insert=false&update=false&delet=ture&" );
    temp.append( "name=" );
    temp.append( name );
    temp.append( "&job=" );
    temp.append( job );
    try {
      System.out.println("open connection to "+servletURL+temp.toString());
      URL url = new java.net.URL( servletURL + temp.toString() );
      AppletContext ac = getAppletContext();
      ac.showDocument(url);
    }
    catch ( MalformedURLException ex ){
     System.err.println( "Can't open URL: " + servletURL + ex );
    }
    catch( IOException e ){
     System.err.println( "Conection is wrong: " + e );
     }
   }//delete
}




  
/** The Control with two panels, connectionPanel with insert, delete,
    update, search, clear, and close buttons; searchPanel with labels and
    textfields which provide to client type in. 
 API:
   Control( Client );
   actionPerformed( ActionEvent );
 */
class Control extends Panel implements ActionListener {

  private Project2_Client parent;
  private TextField name, job, id, inputf, outputf, type, ann;
  private Label lbl;
  private Panel searchPanel;
  private Panel connectionPanel;
  private Button updataPro, searchPro, insert, delete;
  
  /**Input:Project2_Client obj.
     Output:void
     Function:initialize the screen.
  **/
  public Control( Project2_Client clt) {

    parent = clt;
    setLayout(new BorderLayout());
    setFont(new Font("Helvitica", Font.PLAIN, 14));
    searchPanel = new Panel();
    searchPanel.setLayout( new GridLayout( 7, 2 ) );
    connectionPanel = new Panel();

    //buttons for clients.
    updataPro = new Button( "Update Process" );
    delete = new Button( "Delete Process" );
    insert = new Button("Add Process");
    searchPro = new Button("Search Process");

    insert.addActionListener(this);
    delete.addActionListener( this );
    searchPro.addActionListener(this);
    updataPro.addActionListener( this );
    
    connectionPanel.add( insert );
    connectionPanel.add( updataPro );
    connectionPanel.add( delete );
    connectionPanel.add( searchPro );


    searchPanel.add( new Label( "Name of User" ) );
    searchPanel.add( name = new TextField(20));
    searchPanel.add( new Label("Process"));
    searchPanel.add( job = new TextField(20));
    searchPanel.add( new Label("Process ID"));
    searchPanel.add( id = new TextField( 20 ) );
    searchPanel.add( new Label( "Input File" ));
    searchPanel.add( inputf = new TextField( 20 ) );
    searchPanel.add( new Label( "Output File" ));
    searchPanel.add( outputf = new TextField( 20 ) );
    searchPanel.add( new Label( "Type" ));
    searchPanel.add( type = new TextField( 20 ) );
    searchPanel.add( new Label( "Annotation" ));
    searchPanel.add( ann = new TextField( 20 ) );


    add("North",connectionPanel);
    add("South",searchPanel);
  }
  
  /**Input:ActionEvent obj.
     Output:void
     Function:waiting something happen.
  **/
  public void actionPerformed(ActionEvent event) {
    String buttonLabel = event.getActionCommand();
    
    if(buttonLabel.equals("Search Process")) {
    try {
	 System.out.println("search for job: " + name.getText() + job.getText() + id.getText() );
    //look for the process information.
	parent.search( name.getText(), job.getText(), id.getText() );
      }
      catch (Exception ex) {
      }
    }
    if(buttonLabel.equals("Update Process")) {
      try {
         System.out.println("Update process" + job.getText());
    //change data of a process.
    parent.update( name.getText(), job.getText(), id.getText(), inputf.getText(), outputf.getText(),  type.getText(), ann.getText() );
       }
      catch (Exception ex) {
      }
    }

    if(buttonLabel.equals("Add Process")) {
      try {
       System.out.println("Add Process" + job.getText() );
    //add a process to table.
    parent.adddate( name.getText(), job.getText(), id.getText(), inputf.getText(), outputf.getText(), type.getText(), ann.getText() );
      }
      catch (Exception ex) {
      }
    }

    if(buttonLabel.equals("Delete Process")) {
      try {
        System.out.println("Delete Process " + job.getText() );
    //delete a process in the table.
    parent.delete_date( name.getText(), job.getText() );
      }
      catch (Exception ex) {
      }
    }//if
  }//method
}


